//***************************************************************************
//
// $Source$
// $Revision$
//
//
//   Latis Networks, Inc. (d/b/a StillSecure)
//     www.stillsecure.com
//     www.stillsecure.org
//
//
//   Copyright (C) 2005-2006 Latis Networks, Inc. (d/b/a StillSecure)
//
//    This file is part of SAPQ.
//
//    SAPQ is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    SAPQ is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAPQ; if not, write to the Free Software
//    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA
//
//
//     Project: Safe Access Packet Queuing Daemon
//     Module: SAPQ
//     Class: Client
//     Author: Jim Guggemos
//     Description: Class that handles client socket communication.
//
// $Date$
//
//***************************************************************************

#ifndef __Client_H__
#define __Client_H__

#include <pthread.h>
#include <string>

using namespace std;

class Socket;
class HashManager;

class Client
{
public:
    Client(HashManager &hashmgr, Socket *clientSock);
    ~Client();

    bool start();

protected:
    void run();
    void ok();
    void error(const char *format, ...);
    void list(string arg);
    void debug(string arg);
    void stats(string arg);
    void help();
    bool readSocket(string &command);
    
private:
    Socket *m_socket;
    pthread_t m_threadId;
    HashManager &m_hashmgr;

    static void *threadRun(void*);
};


#endif // __Client_H__
