//***************************************************************************
//
// $Source$
// $Revision$
//
//
//   Latis Networks, Inc. (d/b/a StillSecure)
//     www.stillsecure.com
//     www.stillsecure.org
//
//
//   Copyright (C) 2005-2006 Latis Networks, Inc. (d/b/a StillSecure)
//
//    This file is part of SAPQ.
//
//    SAPQ is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    SAPQ is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAPQ; if not, write to the Free Software
//    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA
//
//
//     Project: Safe Access Packet Queuing Daemon
//     Module: SAPQ
//     Class: SocketServer
//     Author: Jim Guggemos
//     Description: Class that monitors listening socket and creates
//                  Client objects (and thread) when a client connects
//                  via TCP socket.
//
// $Date$
//
//***************************************************************************

#ifndef __SocketServer_H__
#define __SocketServer_H__

#include "HashManager.h"
#include <pthread.h>
        
class Socket;

class SocketServer
{
public:
    SocketServer(HashManager &hashmgr, int port);
    virtual ~SocketServer();

    bool start();
    void stop();

protected:
    void run();

private:
    const int m_port;
    pthread_t m_threadId;
    bool m_stop;
    HashManager &m_hashmgr;

    Socket *m_listenSocket;

    static void *threadRun(void*);
};

#endif // __SocketServer_H__
